## shake-1.0-4.src.tar.gz

=== CMakeLists.txt ===
#  Copyright (C) 2006-2011 Brice Arnould.
# 
#  This file is part of ShaKe.
#
#  ShaKe is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
# 
#  This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#  You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

#### MACROS AND WORKAROUNDS ####
CMAKE_MINIMUM_REQUIRED (VERSION 2.4)
if(COMMAND cmake_policy) # Needed by CMake 2.4
  cmake_policy(SET CMP0005 OLD)
endif(COMMAND cmake_policy)
set (CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS true)

MACRO (add_help2man_manpage file command)
  get_target_property (HELP2MAN_COMMAND ${command} LOCATION)
  add_custom_command (OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${file}
    COMMAND ${HELP2MAN_LOCATION} ARGS -s8 -N -i ${CMAKE_CURRENT_SOURCE_DIR}/doc/fdl-man_insert -I ${CMAKE_CURRENT_SOURCE_DIR}/doc/${command}-man_insert -o ${CMAKE_CURRENT_BINARY_DIR}/${file} ${HELP2MAN_COMMAND}
    DEPENDS ${command}
    COMMENT "Building manpage for ${command}")
ENDMACRO ()

#### PROJECT CONFIG ####
project (Shake C)
set (CPACK_VERSION_MAJOR "1")
set (CPACK_VERSION_MINOR "0")
set (CPACK_PACKAGE_CONTACT "Brice Arnould <brice.arnould+shake@gmail.com>")

set (VERSION "${CPACK_VERSION_MAJOR}.${CPACK_VERSION_MINOR}")

#### System checks ####
find_program (HELP2MAN_LOCATION help2man)
IF (NOT HELP2MAN_LOCATION)
  message (SEND_ERROR "Cannot find help2man. Please install it.")
ENDIF ()

#### Targets ####
add_executable (shake executive.c judge.c linux.c main.c msg.c signals.c)
add_executable (unattr executive.c linux.c signals.c unattr.c)
add_help2man_manpage (shake.8 shake)
add_help2man_manpage (unattr.8 unattr)
add_custom_target (doc ALL
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/shake.8
          ${CMAKE_CURRENT_BINARY_DIR}/unattr.8)

#### Platform Specific ####

## LINUX  ##
IF (CMAKE_SYSTEM_NAME MATCHES Linux)
  add_definitions ("-D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64")  # For 64 bits files
  add_definitions ("-D_XOPEN_SOURCE=600 -D_POSIX_C_SOURCE=200112L") # For posix_fallocate
  list (APPEND CMAKE_REQUIRED_LIBRARIES attr)
  target_link_libraries (shake attr)
  target_link_libraries (unattr attr)
ELSE ()
  message ("For now, shake has only been tested under GNU/Linux. I would be really interested by your experience under other OS, if you have time to write me at <brice.arnould+shake@gmail.com>")
ENDIF ()

## GCC  ##
IF (CMAKE_COMPILER_IS_GNUCC)
  set (CMAKE_C_FLAGS "$ENV{CFLAGS} -std=gnu99 -O2 -Wall -Wextra -Wcast-align -Wpointer-arith -Wbad-function-cast -Wno-sign-compare")
  set (CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS} -O0 -ggdb3 -pedantic -Wconversion -Werror -DDEBUG=1")
ENDIF ()

## ALL  ##
INCLUDE (CheckIncludeFiles)
INCLUDE (CheckFunctionExists)
check_function_exists (attr_setf HAVE_LIBATTR)
check_function_exists (fallocate HAVE_FALLOCATE)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/config.h
  ESCAPE_QUOTES)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})

## SANITY CHECK ##
IF (NOT HAVE_LIBATTR)
  message (SEND_ERROR "You need libattr headers for Shake to build. They might be in a package named libattr1-dev or libattr-devel.")
ENDIF()

#### Installation ####
install (TARGETS shake unattr
  DESTINATION bin)
install (FILES ${CMAKE_CURRENT_BINARY_DIR}/shake.8 ${CMAKE_CURRENT_BINARY_DIR}/unattr.8
  DESTINATION share/man/man8)
## Packages ##
set (CPACK_PACKAGE_VERSION_MAJOR ${CPACK_VERSION_MAJOR})
set (CPACK_PACKAGE_VERSION_MINOR ${CPACK_VERSION_MINOR})
set (CPACK_RESOURCE_FILE_LICENSE ${CMAKE_CURRENT_SOURCE_DIR}/GPL.txt)
set (CPACK_GENERATOR "STGZ;TGZ;TZ")
INCLUDE(CPack)

=== debian/changelog ===
shake-fs (1.0) trusty; urgency=high

  * Upstream update

 -- Brice Arnould <brice.arnould+shake@gmail.com>  Wed, 23 Jul 2014 22:00:00 +0000

shake-fs (0.999) maverick; urgency=high

  * Upstream update

 -- Brice Arnould <brice.arnould+shake@gmail.com>  Sat, 26 Mar 2011 00:38:24 +0100

shake-fs (0.99) intrepid; urgency=high

  * Upstream update.
  * SECURITY UPDATE: Printf of a user-controled string.
  * References
  *  commit 8cc0d32580f99bef2003fa387994859c7b63bd0e

 -- Brice Arnould <brice.arnould+shake@gmail.com>  Sat, 31 Jan 2009 12:36:24 -0800

shake-fs (0.31) unstable; urgency=low
  * Upstream update.

 -- Brice Arnould <brice.arnould+shake@gmail.com>  Sun, 2 Feb 2008 16:01:08 +0100

shake-fs (0.30) unstable; urgency=low
  * Initial Release.
 -- Brice Arnould <brice.arnould+shake@gmail.com>  Sun, 30 Dec 2007 11:51:08 +0100

=== PKGBUILD ===
# Maintainer : Jaroslav Lichtblau <svetlemodry@archlinux.org>
# Contributor : Allan McRae <allan@archlinux.org>
# Contributor: Julien MISCHKOWITZ <wain@archlinux.fr>

pkgname=shake
pkgver=1.0
pkgrel=4
pkgdesc="Userspace defragmenter that can be run while system is in use"
arch=('x86_64')
url="https://vleu.net/shake/"
license=('GPL3')
depends=('attr')
makedepends=('cmake' 'help2man')
install=$pkgname.install
source=($pkgname-$pkgver.tar.gz::https://github.com/unbrice/shake/archive/v$pkgver.tar.gz)
sha512sums=('f73601ebf37ac934b2cfb5bcedd530e38bd6873615e80eae01c690bf935ed3924abb1d06fb31c46397b5804d47a36584ac5e11b4c7142b46e570ddbf3abe1775')

build() {
  cd "${srcdir}"/${pkgname}-${pkgver}/build

  cmake -DCMAKE_BUILD_TYPE=Release \
        -DCMAKE_INSTALL_PREFIX=/usr ..
  make
}

package() {
  cd "${srcdir}"/${pkgname}-${pkgver}/build

  make DESTDIR="${pkgdir}" install
}

=== debian/control ===
Source: shake-fs
Section: admin
Priority: optional
Maintainer: Brice Arnould <brice.arnould+shake@gmail.com>
Build-Depends: cdbs (>= 0.4.50), cmake (>= 2.4), debhelper (>= 5), help2man (>= 1.26), libattr1-dev (>= 2.0.0)
Standards-Version: 3.8.0
Homepage: http://vleu.net/shake/

Package: shake-fs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Defragmenter (rewrite fragmented or misplaced files)
 Shake is a defragmenter that runs in userspace.
 There is no black magic involved : it works just by rewriting
 misplaced fragments. But it has some heuristics that could make it
 more efficient than other tools, including defrag and, maybe,
 xfs_fsr.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/class/cmake.mk

CC  = /usr/bin/cc
CXX = /usr/bin/g++

#DEB_DH_INSTALL_SOURCEDIR = debian/tmp
